%% Plots simulation results

orange = [255 184 77]/255;
lightblue = [117 221 255]/255;
lightred = [255 100 100]/255;
purple = [155 39 176]/255;
green = [56 140 0]/255;
linewf = 1;
linew = 2;
num = 20;

if(any(findall(0,'Type','Figure')==num)),
     close(num);
end;
figure(num)
NO1 = load('NO1.mat');
NO2 = load('NO2.mat');
NO3 = load('NO3.mat');
NO4 = load('NO4.mat');
NO5 = load('NO5.mat');
SE1 = load('SE1.mat');
SE2 = load('SE2.mat');
SE3 = load('SE3.mat');
SE4 = load('SE4.mat');
FI = load('FI.mat');
DK2 = load('DK2.mat');
FRRA = load('FRR-A.mat');
flow = load('flow.mat');
steps = NO1.data.primary.f.time*0+1;

subplot(2,1,1)
nof=plot(NO1.data.primary.f, 'b', 'Linewidth', linewf); hold on;
plot(NO2.data.primary.f, 'b', 'Linewidth', linewf);
plot(NO3.data.primary.f, 'b', 'Linewidth', linewf);
plot(NO4.data.primary.f, 'b', 'Linewidth', linewf);
plot(NO5.data.primary.f, 'b', 'Linewidth', linewf);
sef=plot(SE1.data.primary.f, 'Color', green, 'Linewidth', linewf);
plot(SE2.data.primary.f, 'Color', green, 'Linewidth', linewf);
plot(SE3.data.primary.f, 'Color', green, 'Linewidth', linewf);
plot(SE4.data.primary.f, 'Color', green, 'Linewidth', linewf);
fif=plot(FI.data.primary.f, 'Color', lightblue, 'Linewidth', linewf);
dkf=plot(DK2.data.primary.f, 'Color', lightred, 'Linewidth', linewf);
grid on; 
plot(NO1.data.primary.f.time, steps*49.90, 'r--');
plot(NO1.data.primary.f.time, steps*50.10, 'r--');
plot(NO1.data.primary.f.time, steps*49.95, '--', 'Color', orange);

plot(NO1.data.primary.f.time, steps*50.05, '--', 'Color', orange);
% title('Frequency');
ylabel('Frequency [Hz]');
legend([nof sef fif dkf],{'NO1-NO5', 'SE1-SE4', 'FI', 'DK2'});

subplot(2,1,2)
tot_P_m =  (NO1.data.primary.P_m.data + ...
            NO2.data.primary.P_m.data + ...
            NO3.data.primary.P_m.data + ...
            NO4.data.primary.P_m.data + ...
            NO5.data.primary.P_m.data + ...
            SE1.data.primary.P_m.data + ...
            SE2.data.primary.P_m.data + ...
            SE3.data.primary.P_m.data + ...
            SE4.data.primary.P_m.data + ...
            FI.data.primary.P_m.data + ...
            DK2.data.primary.P_m.data)*L;
tot_frra =  (NO1.data.secondary.FRR_A_d.data + ...
            NO2.data.secondary.FRR_A_d.data + ...
            NO3.data.secondary.FRR_A_d.data + ...
            NO4.data.secondary.FRR_A_d.data + ...
            NO5.data.secondary.FRR_A_d.data + ...
            SE1.data.secondary.FRR_A_d.data + ...
            SE2.data.secondary.FRR_A_d.data + ...
            SE3.data.secondary.FRR_A_d.data + ...
            SE4.data.secondary.FRR_A_d.data + ...
            FI.data.secondary.FRR_A_d.data + ...
            DK2.data.secondary.FRR_A_d.data)*L;
tot_load =  (NO1.data.primary.load.data + ...
            NO2.data.primary.load.data + ...
            NO3.data.primary.load.data + ...
            NO4.data.primary.load.data + ...
            NO5.data.primary.load.data + ...
            SE1.data.primary.load.data + ...
            SE2.data.primary.load.data + ...
            SE3.data.primary.load.data + ...
            SE4.data.primary.load.data + ...
            FI.data.primary.load.data + ...
            DK2.data.primary.load.data)*L;
tot_u =  (NO1.data.secondary.u.data + ...
            NO2.data.secondary.u.data + ...
            NO3.data.secondary.u.data + ...
            NO4.data.secondary.u.data + ...
            NO5.data.secondary.u.data + ...
            SE1.data.secondary.u.data + ...
            SE2.data.secondary.u.data + ...
            SE3.data.secondary.u.data + ...
            SE4.data.secondary.u.data + ...
            FI.data.secondary.u.data + ...
            DK2.data.secondary.u.data)*L;
tot_ACE =  (NO1.data.secondary.ACE.data + ...
            NO2.data.secondary.ACE.data + ...
            NO3.data.secondary.ACE.data + ...
            NO4.data.secondary.ACE.data + ...
            NO5.data.secondary.ACE.data + ...
            SE1.data.secondary.ACE.data + ...
            SE2.data.secondary.ACE.data + ...
            SE3.data.secondary.ACE.data + ...
            SE4.data.secondary.ACE.data + ...
            FI.data.secondary.ACE.data + ...
            DK2.data.secondary.ACE.data)*L;

plot(NO1.data.primary.load.time, tot_load, 'Color', orange, 'Linewidth', linew); hold on;
plot(NO1.data.primary.P_m.time, tot_P_m, 'b', 'Linewidth', linew); 
plot(NO1.data.secondary.u.time, tot_u, 'Color', green, 'Linewidth', linew);
plot(NO1.data.secondary.ACE.time, tot_ACE, 'Color', purple, 'Linewidth', linew);
plot(NO1.data.secondary.FRR_A_d.time, tot_frra, 'r', 'Linewidth', linew);
%plot(flow.data.filtered.time, flow.data.filtered.data(:,2)*L);
%plot(FRRA.data.flow_d.time,FRRA.data.flow_d.data(:,2));

% plot(NO1.data.secondary.FRR_A_d*L, '--'); 
% plot(NO2.data.secondary.FRR_A_d*L, '--');
% plot(NO3.data.secondary.FRR_A_d*L, '--');
% plot(NO4.data.secondary.FRR_A_d*L, '--');
% plot(NO5.data.secondary.FRR_A_d*L, '--');
grid on;
% title('Load vs FRR-A production');
xlabel('Time [s]');
ylabel('Power [MW]');
legend('Total load', 'Total \DeltaP_{m}', 'Total demand', 'Total ACE', 'Total FRR-A');

if(any(findall(0,'Type','Figure')==num+1)),
     close(num+1);
end;
figure(num+1)
subplot(1,2,1)
title('FRR-A total cost');
plot(FRRA.data.FRR_A_cost.time, FRRA.data.FRR_A_cost.data);
grid on;
xlabel('Time [s]');
ylabel('FRR-A Cost [NOK]');

subplot(1,2,2)
plot(FRRA.data.shortage.time, FRRA.data.shortage.data);
grid on;
title('Not Covered Demand');
ylabel('[MW]');
xlabel('Time [s]');