%% Plots simulation results

orange = [255 184 77]/255;
lightblue = [117 221 255]/255;
lightred = [255 100 100]/255;
purple = [155 39 176]/255;
green = [56 140 0]/255;
linewf = 2;
linew = 2;
num = 21;

if(any(findall(0,'Type','Figure')==num)),
     close(num);
end;
figure(num)
NO1 = load('NO1.mat');
NO2 = load('NO2.mat');
NO3 = load('NO3.mat');
NO4 = load('NO4.mat');
NO5 = load('NO5.mat');
SE1 = load('SE1.mat');
SE2 = load('SE2.mat');
SE3 = load('SE3.mat');
SE4 = load('SE4.mat');
FI = load('FI.mat');
DK2 = load('DK2.mat');
FRRA = load('FRR-A.mat');
flow = load('flow.mat');
steps = NO1.data.primary.f.time*0+1;

subplot(2,1,1)
nof=plot(NO1.data.primary.f.time,NO1.data.primary.f.data, 'b', 'Linewidth', linewf); hold on;
grid on; 
plot(NO1.data.primary.f.time, steps*49.90, 'r--');
plot(NO1.data.primary.f.time, steps*50.10, 'r--');
plot(NO1.data.primary.f.time, steps*49.95, '--', 'Color', orange);

plot(NO1.data.primary.f.time, steps*50.05, '--', 'Color', orange);
% title('Frequency');
ylabel('Frequency [Hz]');
legend('Common frequency');
xlabel('Time [s]');

tot_NO =  (NO1.data.secondary.FRR_A_d.data + ...
            NO2.data.secondary.FRR_A_d.data + ...
            NO3.data.secondary.FRR_A_d.data + ...
            NO4.data.secondary.FRR_A_d.data + ...
            NO5.data.secondary.FRR_A_d.data)*L;
tot_SE =    (SE1.data.secondary.FRR_A_d.data + ...
            SE2.data.secondary.FRR_A_d.data + ...
            SE3.data.secondary.FRR_A_d.data + ...
            SE4.data.secondary.FRR_A_d.data)*L;
tot_FI =    FI.data.secondary.FRR_A_d.data*L;
tot_DK =    DK2.data.secondary.FRR_A_d.data*L;

FRRA_mat(:,1) = NO1.data.secondary.FRR_A_d.data'*L;
FRRA_mat(:,2) = NO2.data.secondary.FRR_A_d.data'*L;
FRRA_mat(:,3) = NO3.data.secondary.FRR_A_d.data'*L;
FRRA_mat(:,4) = NO4.data.secondary.FRR_A_d.data'*L;
FRRA_mat(:,5) = NO5.data.secondary.FRR_A_d.data'*L;
FRRA_mat(:,8) = SE1.data.secondary.FRR_A_d.data'*L;
FRRA_mat(:,9) = SE2.data.secondary.FRR_A_d.data'*L;
FRRA_mat(:,10) = SE3.data.secondary.FRR_A_d.data'*L;
FRRA_mat(:,11) = SE4.data.secondary.FRR_A_d.data'*L;
FRRA_mat(:,6) = FI.data.secondary.FRR_A_d.data'*L;
FRRA_mat(:,7) = DK2.data.secondary.FRR_A_d.data'*L;

% FRRA_mat_land(:,2) = tot_NO';
% FRRA_mat_land(:,4) = tot_SE';
% FRRA_mat_land(:,1) = tot_FI';
% FRRA_mat_land(:,3) = tot_DK';
% figure(28)
% area(NO1.data.secondary.FRR_A_d.time,FRRA_mat_land)
% legend('FI', 'NO', 'DK', 'SE')
% xlabel('Time [s]')
% ylabel('Activated FRR-A [MW]'); 

subplot(2,2,3)
h1 = area(NO1.data.secondary.FRR_A_d.time,FRRA_mat);
legend('NO1','NO2','NO3','NO4','NO5', 'FI' , 'DK2', 'SE1','SE2','SE3','SE4');
xlabel('Time [s]')
ylabel('FRR-A activated [MW]'); 
grid on;

tot_u =  (NO1.data.secondary.u.data + ...
            NO2.data.secondary.u.data + ...
            NO3.data.secondary.u.data + ...
            NO4.data.secondary.u.data + ...
            NO5.data.secondary.u.data + ...
            SE1.data.secondary.u.data + ...
            SE2.data.secondary.u.data + ...
            SE3.data.secondary.u.data + ...
            SE4.data.secondary.u.data + ...
            FI.data.secondary.u.data + ...
            DK2.data.secondary.u.data)*L;

subplot(2,2,4)
plot(FRRA.data.FRR_A_cost.time, FRRA.data.FRR_A_cost.data, 'b', 'Linewidth', linew); hold on;
xlabel('Time [s]')
ylabel('FRR-A cost [NOK]'); 
grid on;

