function plot_area(matfile, L, figure_nr)

%% Plots simulation results
set(0,'defaultlinelinewidth',1)
orange = [255 184 77]/255;
num = 25;

if(any(findall(0,'Type','Figure')==figure_nr)),
     close(figure_nr);
end;
figure(figure_nr)
area = load(matfile);

steps = area.data.primary.f.time*0+1;

subplot(2,1,1)
plot(area.data.primary.f);
grid on; hold on;
plot(area.data.primary.f.time, steps*49.90, 'r--', 'LineWidth',.5);
plot(area.data.primary.f.time, steps*50.10, 'r--', 'LineWidth',.5);
plot(area.data.primary.f.time, steps*49.95, '--', 'Color', orange, 'LineWidth',.5);
plot(area.data.primary.f.time, steps*50.05, '--', 'Color', orange, 'LineWidth',.5);
%title('Frequency');
ylabel('Frequency [Hz]');

subplot(2,1,2)
plot(area.data.primary.P_m*L); hold on;
plot(area.data.secondary.FRR_A_d*L);
plot(area.data.primary.load.time,area.data.primary.load.data*L);
plot(area.data.secondary.ACE*L);
plot(area.data.secondary.tieline_filtered*L);
%plot(area.data.primary.tieline*L);
plot(area.data.secondary.tieline_d*L, '--');
grid on;
%title('P_m');
xlabel('Time [s]');
ylabel('[MW]');
legend('P_m', 'FRR-A_{ref}', 'Load', 'ACE', 'Tie-line filtered', 'Tie-line_d');

end
