demands = [0 0 0 0 0 0 0 200 0 0 0]';

bidList = xlsread('bids/FRR-A_bids_all_mixed');
[Q_min, Q_max, C] = generateBidMat(bidList, 11);

%% Tieline Parameters
% TIE-LINE CONNECTION MATRIX
% [branches, nodes]
A = [   1   -1  0   0   0   0   0   0   0   0   0;      % B1
        1   0   -1  0   0   0   0   0   0   0   0;      % B2
        1   0   0   0   -1  0   0   0   0   0   0;      % B3
        1   0   0   0   0   0   0   -1  0   0   0;      % B4
        0   1   0   0   -1  0   0   0   0   0   0;      % B5
        0   0   1   0   -1  0   0   0   0   0   0;      % B6
        0   0   1   -1  0   0   0   0   0   0   0;      % B7
        0   0   1   0   0   0   -1  0   0   0   0;      % B8
        0   0   0   1   0   -1  0   0   0   0   0;      % B9
        0   0   0   1   0   0   -1  0   0   0   0;      % B10
        0   0   0   1   0   0   0   0   0   -1  0;      % B11
        0   0   0   0   0   1   -1  0   0   0   0;      % B12
        0   0   0   0   0   1   0   0   0   -1  0;      % B13
        0   0   0   0   0   0   1   -1  0   0   0;      % B14
        0   0   0   0   0   0   0   1   -1  0   0;      % B15
        0   0   0   0   0   0   0   0   1   0   -1];    % B16

% Tie-line connection matrix #2
branches = [1 2; 1 3; 1 5; 1 8; 2 5; 3 5; 3 4; 3 7; 4 6; 4 7; 4 10; 6 7; 6 10; 7 8; 8 9; 9 11];
    
% Capacity
minFlowVector = [-1000 -1000 -1000 -1000 -1000 -1000 -1000 -1000 ...
                 -1000 -1000 -1000 -1000 -1000 -1000 -1000 -1000]';
maxFlowVector = [1000 1000 1000 1000 1000 1000 1000 1000 ...
                 1000 1000 1000 1000 1000 1000 1000 1000]';

flowCost = 0.001;
activationCost = 1;             
%% Tieline Admittance


Y = [3.00 3.10 2.90 3.15 2.98 2.95 3.16 2.97 3.01 2.87 3.22 3.14 2.89 2.95 2.85 3.01]; 
% Model of admittance with error
Y_m = ones(1,16) * 3;

% Admittance matrix must have zeros on diagonal
Ymat = ...
        [0      Y(1)    Y(2)    0       Y(3)    0       0       Y(4)    0       0       0;
        Y(1)    0       0       0       Y(5)    0       0       0       0       0       0;
        Y(2)    0       0       Y(7)    Y(6)    0       Y(8)    0       0       0       0;
        0       0       Y(7)    0       0       Y(9)    Y(10)   0       0       Y(11)   0;
        Y(3)    Y(5)    Y(6)    0       0       0       0       0       0       0       0;
        0       0       0       Y(9)    0       0       Y(12)   0       0       Y(13)   0;
        0       0       Y(8)    Y(10)   0       Y(12)   0       Y(14)   0       0       0;
        Y(4)    0       0       0       0       0       Y(14)   0       Y(15)   0       0;
        0       0       0       0       0       0       0       Y(15)   0       0       Y(16);
        0       0       0       Y(11)   0       Y(13)   0       0       0       0       0;
        0       0       0       0       0       0       0       0       Y(16)   0       0];

Ymat_model = ...
        [0       Y_m(1)  Y_m(2)  0       Y_m(3)  0       0       Y_m(4)  0       0       0;
        Y_m(1)  0       0       0       Y_m(5)  0       0       0       0       0       0;
        Y_m(2)  0       0       Y_m(7)  Y_m(6)  0       Y_m(8)  0       0       0       0;
        0       0       Y_m(7)  0       0       Y_m(9)  Y_m(10) 0       0       Y_m(11) 0;
        Y_m(3)  Y_m(5)  Y_m(6)  0       0       0       0       0       0       0       0;
        0       0       0       Y_m(9)  0       0       Y_m(12) 0       0       Y_m(13) 0;
        0       0       Y_m(8)  Y_m(10) 0       Y_m(12) 0       Y_m(14) 0       0       0;
        Y_m(4)  0       0       0       0       0       Y_m(14) 0       Y_m(15) 0       0;
        0       0       0       0       0       0       0       Y_m(15) 0       0       Y_m(16);
        0       0       0       Y_m(11) 0       Y_m(13) 0       0       0       0       0;
        0       0       0       0       0       0       0       0       Y_m(16) 0       0];
    

    
% Generate B_prime matrix 
B_prime = (diag(sum(Ymat_model,2)') - Ymat_model);  

% Negative suseptence 
D = diag(Y_m);      



